DEFINE CLASS dates_1facture AS custom
  * liste des dates utilises pour une facture
  debut_periode = {}   && date dbut de la priode de facturation
  fin_periode   = {}   && fin de la priode de facturation
  nbre_echeance = 0    && nombre d'chances (_assign)
  DIMENSION echeances(1) && liste des dates d'chance
  test_modif = {}      && date  partir de laquelle on vrifie les modifs
  *                       des parents et des lves
  PROCEDURE init
  
  ENDPROC
  
  PROCEDURE nbre_echeance_assign
    LPARAMETERS pnnouvaleur
    
    IF BETWEEN(M.pnnouvaleur, 1, 5)
      This.nbre_echeance = pnnouvaleur
      DIMENSION This.echeances(pnnouvaleur)
      STORE {} TO This.echeances
    ENDIF && BETWEEN(M.pnnouvaleur, 1, 5)
  ENDPROC && nbre_echeance_assign

ENDDEFINE && CLASS dates_1facture AS custom

DEFINE CLASS dates AS custom
  * liste des dates principales utilises dans l'application
  * les principales mthodes sont :
  *   lecture_dates_principales  lecture rentree et sortie
  *   enregistrement_dates_principales
  *   lecture_annee_scolaire annee_scolaire, lettre_annee, semaine1, rentree, sortie
  *   moicivsco  mois civil vers mois scolaire
  *   moiscociv  mois scolaire vers mois civil
  *   datdebmoi  date du premier du mois pass en paramtre
  *   datfinmoi  date fin du mois pass en paramtre
  *   anneenum_to_lettreannee  1992 -> A 2005-> N
  *   lecture_vacances
  *   ajout_vacances
  *   modification_vacances
  *   suppression_vacances
  *   enregistrement_vacances

  annee_scolaire = 0  && anne scolaire numrique
                      && cette proprit a 2 mthodes _assign et _access
                      && _assign va permettre de mettre  jour les proprits
                      && annexes et _access va permettre la mise  jour de
                      && annee_scolaire au moment de la premire utilisation
  lettre_annee = ""   && lettre code anne scolaire (dans la version DOS et donc dans
                      && les tables, index correspondant on utilise l'anne numrique
                      && et dans la partie purement VFP la code lettre de l'anne
                      && (ya lettre_annee_assign)
  texte_annee = ""    && ex '2004'
  texte_annee_scolaire = "" && ex '2004-2005'
  rentree = {}        && date de la rentre
  julrentree = 0      && date julienne correspondant  la rentre
  sortie  = {}        && date de la sortie
  lundi_semaine1 = {} && premier lundi qui suit le 1er aot qui prcde la 
                      && date de rentre. Ce lundi est la base de tous
                      && les calculs de date pour l'anne scolaire en 
                      && particulier lorsqu'il s'agit de retrouver
                      && le bit corespondant dans une chane de 53 caractres.
  julsem1 = 0         && numro du jour julien correspondant  lundi_semaine1
                      && VFP utilise beaucoup les dates juliennes.
  nbre_trimestre = 0  && nombre de trimestre
  DIMENSION trimestres(1,2) && date dbut/fin de chaque trimestre
  nbre_facture = 0    && nombre de factures pour l'anne scolaire
  DIMENSION factures(1, 2)  && dates et codes des factures
  nbre_vacances = 0   && nombre de priodes de vacances (ya nbre_vacances_access)
  DIMENSION vacances(1,3) && dates des vacances 1 dbut  2 fin  3 libell
                          && (ya vacances_access)
  yamodif_vacances = .F.  && .T. si les vacances ont t modifies
  
  PROCEDURE init
  ENDPROC && init
  
  PROCEDURE destroy && jme 18/08/2005
    WITH This
      * si on ne veut pas enregistrer les vacances en dtruisant l'objet,
      * il faut penser  remettre  .F. yamodif_vacances
      IF .yamodif_vacances
        .enregistrement_vacances()
      ENDIF && yamodif_vacances
    ENDWITH  && This
    DODEFAULT()
  ENDPROC && destroy

  * l'application est tire d'une appli DOS qui fonctionne encore mais
  * entretemps on a modifi la gestion des annes scolaires ...
  * les vnements _ASSIGN nous permettent de grer ce problme facilement
  * (avant on n'utilisait que des annes numriques, maintenant que des lettres code)
  HIDDEN PROCEDURE annee_scolaire_ASSIGN
    * chaque fois que l'on met une valeur dans annee_scolaire on passe ici
    LPARAMETERS pnannee
    
    WITH This
	    .annee_scolaire = pnannee
	    IF pnannee > 1991
		    .lettre_annee = CHR(65 + pnannee - 1992)
	      .texte_annee = STR( m.pnannee,4)
	      .texte_annee_scolaire = .texte_annee+"-"+STR( m.pnannee+1,4)
	      .lundi_semaine1 = CTOD("01/08/" + .texte_annee)
			  DO WHILE DOW( .lundi_semaine1,1) <> 2
			    .lundi_semaine1 = .lundi_semaine1 + 1
			  ENDDO
			  .julsem1 = VAL( SYS(11, .lundi_semaine1))
	    ELSE
		    STORE "" TO .lettre_annee, .texte_annee, .texte_annee_scolaire
	      .lundi_semaine1 = {}
			  .julsem1 = 0
	    ENDIF && pnannee > 1992
	    * quand on change d'anne scolaire, il faut RAZ les vacances, les factures, ...
	    .raz_dates_annee()
      IF USED("vfpmou")
	      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70100, ;
	        "annee_scolaire_assign", "elvclass.dates", "", "", "", pnannee)
      ENDIF && USED("vfpmou")
	    * et mettre  jour les dates principales (il ne faut pas lire l'anne scolaire
	    * car cela remettrait .annee_scolaire  la valeur initiale)
      .lecture_dates_principales()
    ENDWITH  && This
  ENDPROC && annee_scolaire_ASSIGN
  
  HIDDEN PROCEDURE annee_scolaire_ACCESS
    * on veut lire l'anne scolaire, on vrifie qu'elle a bien t mise  jour
    * avec cette simple mthode on laisse la libert au dveloppeur de mettre
    *  jour annee_scolaire au dbut de l'application ou de ne rien faire
    * et dans ce cas la proprit est mise  jour  la premire utilisation
    IF This.annee_scolaire = 0
      * l'anne scolaire n'a pas t mise  jour, on le fait
      This.lecture_annee_scolaire()
      * j'ai vrifi : malgr que l'on relise this.annee_scolaire dans 
      * This.lecture_dates_principales, on ne relance pas cette mthode _access.
    ENDIF && This.annee_scolaire = 0
    RETURN This.annee_scolaire
  ENDPROC && annee_scolaire_ACCESS
  
  HIDDEN PROCEDURE lettre_annee_ASSIGN
    LPARAMETERS pclettre
    * VFP est intelligent ! dans cette mthode on met  jour This.annee_scolaire sur 
    * laquelle il y a un _assign qui remet  jour lettre_annee. Il pourrait donc
    * y avoir une boucle infinie, mais non !
    * par contre annee_scolaire_assign est bien lance
        
    This.lettre_annee = pclettre
    This.annee_scolaire = 1992 - 65 + ASC(pclettre)
  ENDPROC && lettre_annee_ASSIGN
  
  HIDDEN PROCEDURE lettre_annee_ACCESS
    * on veut lire la lettre code de l'annee, on vrifie qu'elle 
    * a bien t mise  jour
    IF This.annee_scolaire = 0 && c'est bien annee_scolaire que l'on teste !
      * l'anne scolaire n'a pas t mise  jour, on le fait
      This.lecture_annee_scolaire()
    ENDIF && This.annee_scolaire = 0
    RETURN This.lettre_annee
  ENDPROC && lettre_annee_ACCESS
  
  HIDDEN PROCEDURE raz_dates_annee
    WITH This
	    STORE 0 TO .nbre_trimestre, .nbre_facture, .nbre_vacances
	    DIMENSION .trimestres(1,2), .factures(1,2), vacances(1,3)
	    STORE {} TO .vacances(1,1), .vacances(1,2), .factures(1,1), ;
	     .trimestres(1,1), .trimestres(1,2)
	    STORE "" TO .vacances(1,3), .factures(1,2)
    ENDWITH  && This
  ENDPROC && raz_dates_annee

  HIDDEN PROCEDURE nbre_vacances_access
    WITH This
	    IF .nbre_vacances = 0
	      * a priori les vacances ne sont pas encore  jour, on le fait ici
	      IF .annee_scolaire > 0
	        * il se peut que l'anne scolaire n'ait pas t mise  jour. Mais
	        * on vient de la lire donc de la mettre  jour. Par contre, si elle
	        * n'est pas dfinie dans parametr, elle est toujours = 0 et ce 
	        * n'est pas la peine de chercher les vacances !
	        .lecture_vacances()
	      ELSE
	        .nbre_vacances = 0
	        DIMENSION .vacances(1,3)
	        STORE {} TO .vacances(1,1), .vacances(1,2)
	        STORE "" TO .vacances(1,3)
	      ENDIF && .annee_scolaire > 0
	    ENDIF && .nbre_vacances = 0
	    RETURN .nbre_vacances
    ENDWITH  && This
  ENDPROC && nbre_vacances_access
  
  HIDDEN PROCEDURE vacances_access && attention vacances est un tableau !
    * idem nbre_vacances_access
    LPARAMETERS lnligne, lncolonne
    
    WITH This
	    IF .nbre_vacances = 0
	      * a priori les vacances ne sont pas encore  jour, on le fait ici
	      IF .annee_scolaire > 0 && il y a un _access sur annee_scolaire
	        * il se peut que l'anne scolaire n'ait pas t mise  jour. Mais
	        * on vient de la lire donc de la mettre  jour. Par contre, si elle
	        * n'est pas dfinie dans parametr, elle est toujours = 0 et ce 
	        * n'est pas la peine de chercher les vacances !
	        .lecture_vacances()
	      ELSE
	        .nbre_vacances = 0
	        DIMENSION .vacances(1,3)
	        STORE {} TO .vacances(1,1), .vacances(1,2)
	        STORE "" TO .vacances(1,3)
	      ENDIF && This.annee_scolaire > 0
	    ENDIF && This.nbre_vacances = 0
	    RETURN .vacances( M.lnligne, M.lncolonne)
    ENDWITH  && This
  ENDPROC && nbre_vacances_access
  
  PROCEDURE lecture_dates_principales
    * jme 10/04/2005 en scurit, on continue  mettre  jour les variables PUBLIC
    * daterentr, julrentr et datsortie
    LOCAL lnseldep, lnannee
    
    WITH This
	    lnseldep = SELECT(0)
	    lnannee = .annee_scolaire
	    SELECT 0
		  USE (repfich+"parametr") ALIAS prmtldp NOUPDATE SHARED AGAIN
		  LOCATE FOR prmtldp->code = "DRT" AND prmtldp->num = m.lnannee
		  STORE IIF( FOUND(), prmtldp->date, .lundi_semaine1) TO daterentr, .rentree
		  STORE VAL( SYS(11, daterentr)) TO .julrentree, julrentr
		  * dernier jour d'cole (grandes vacances)
		  LOCATE FOR prmtldp->code = "DSO" AND prmtldp->num = m.lnannee
		  STORE IIF( FOUND(), prmtldp->date, daterentr +320) TO datsortie, .sortie
		  USE
		  SELECT (M.lnseldep)
    ENDWITH  && This
  ENDPROC &&  lecture_dates_principales

  PROCEDURE lecture_annee_scolaire
    * on lit l'anne scolaire courante dans la table des paramtres puis
    * on met  jour les dates principales (rentre, sortie, ...)
    * en scurit, on continue  mettre  jour les variables PUBLIC
    LOCAL lnseldep, lnannee
    
    WITH This
	    lnseldep = SELECT(0)
	    SELECT 0
		  USE (repfich+"parametr") ALIAS prmtlas NOUPDATE SHARED AGAIN
		  LOCATE FOR prmtlas->code = "AS "  && anne scolaire
		  IF FOUND()
		    STORE prmtlas->num TO M.annscola, .annee_scolaire, m.lnannee
			  * le fait de mettre  jour This.annee_scolaire va dclencher _assign 
			  * et donc la mise  jour des autres valeurs lies ... C'est magique !
		    * et cela RAZ les donnes des trimestres, factures, vacances, ....
		    * on met la proprit annee_scolaire dans lnannee pour
		    * viter de dclencher la mthode access  chaque boucle des LOCATE
			  anscoltxt = .texte_annee
			  anscolltr = .lettre_annee
			  semaine1= .lundi_semaine1
			  julsem1 = .julsem1
			  LOCATE FOR prmtlas->code = "DRT" AND prmtlas->num = m.lnannee
			  STORE IIF( FOUND(), prmtlas->date, .lundi_semaine1) TO daterentr, .rentree
			  STORE VAL( SYS(11, daterentr)) TO .julrentree, julrentr
			  * dernier jour d'cole (grandes vacances)
			  LOCATE FOR prmtlas->code = "DSO" AND prmtlas->num = m.lnannee
			  STORE IIF( FOUND(), prmtlas->date, daterentr +320) TO datsortie, .sortie
		  ENDIF
		  USE
		  SELECT (M.lnseldep)
    ENDWITH  && This
  ENDPROC &&  lecture_annee_scolaire

  PROCEDURE lecture_vacances && jme 10/04/2005
    LOCAL lnseldep, llouvvacan, lnaccu, lnascol, lnnbvac
    * on ne met  jour .nbre_vacances qu' la fin de cette mthode
    * pour viter de dclencher les mthodes assign et access  chaque
    * itration. lnnbvac sert de variable intermdiaire
    
    WITH This
	    lnseldep = SELECT(0)
	    IF !USED("vacan")
	      USE (repfich+"vacances") ALIAS vacan SHARED AGAIN IN 0 NOUPDATE
	      llouvvacan = .T.
	    ELSE
	      llouvvacan = .F.
	    ENDIF && !USED("vacan")
	    * on met la proprit annee_scolaire dans une variable locale pour
	    * viter de dclencher la mthode access  chaque ligne de la table
	    lnascol = .annee_scolaire
	    SELECT datdebut, datfin, libelle FROM vacan ;
	     WHERE ascol = m.lnascol ORDER BY datdebut INTO CURSOR tmpvac
      lnnbvac = RECCOUNT()   && nombre de priodes de vacances
      IF m.lnnbvac > 0
        DIMENSION This.vacances( m.lnnbvac, 3)
        lnaccu = 1
        SCAN ALL
          .vacances( m.lnaccu, 1) = tmpvac.datdebut
          .vacances( m.lnaccu, 2) = tmpvac.datfin
          .vacances( m.lnaccu, 3) = tmpvac.libelle
          lnaccu = m.lnaccu + 1
        ENDSCAN
      ELSE
        DIMENSION This.vacances( 1, 3)
        STORE {} TO .vacances(1,1), .vacances(1,2)
        STORE "aucune vacance programme" TO .vacances(1,3)
      ENDIF && .nbre_vacances > 0
      USE IN tmpvac
      IF llouvvacan = .T.
        USE IN vacan
      ENDIF && llouvvacan = .T.
      SELECT (M.lnseldep)
      .nbre_vacances = m.lnnbvac
      .yamodif_vacances = .F.
    ENDWITH  && This
  ENDPROC && lecture_vacances

  PROCEDURE enregistrement_dates_principales && jme 19/08/2005
    LOCAL lnseldep, lnannee
    
    WITH This
	    IF !EMPTY( .rentree)
		    lnseldep = SELECT(0)
		    lnannee = .annee_scolaire
		    SELECT 0
			  USE (repfich+"parametr") ALIAS prmtedp SHARED AGAIN
			  LOCATE FOR prmtedp->code = "DRT" AND prmtedp->num = m.lnannee
			  IF FOUND()
			    IF prmtedp.date <> .rentree
			      REPLACE date WITH .rentree, carac WITH ;
			       "date rentre modifie "+ DTOC(m.datefox)
			    ENDIF && prmtedp.date <> .rentree
			  ELSE
			    APPEND BLANK
			    REPLACE code WITH "DRT", num WITH m.lnannee, ;
			     date WITH .rentree, carac WITH "date rentre cre "+ DTOC(m.datefox)
			  ENDIF && FOUND()
			  IF !EMPTY(.sortie)
				  LOCATE FOR prmtedp->code = "DSO" AND prmtedp->num = m.lnannee
				  IF FOUND()
				    IF prmtedp.date <> .sortie
				      REPLACE date WITH .sortie, carac WITH ;
				       "date sortie modifie "+ DTOC(m.datefox)
				    ENDIF && prmtedp.date <> .rentree
				  ELSE
				    APPEND BLANK
				    REPLACE code WITH "DSO", num WITH m.lnannee, ;
				     date WITH .sortie, carac WITH "date sortie cre "+ DTOC(m.datefox)
				  ENDIF && FOUND()
			  ENDIF && !EMPTY(.sortie)
			  USE
	      IF USED("vfpmou")
		      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70101, ;
		        "enregistrement_dates_principales", "elvclass.dates", ;
		        DTOC(.rentree) +" "+ DTOC(.sortie), "", "", 0)
	      ENDIF && USED("vfpmou")
	      SELECT (M.lnseldep)
	    ENDIF && !EMPTY( .rentree)
    ENDWITH  && This
  ENDPROC &&  enregistrement_dates_principales

  PROCEDURE enregistrement_vacances && jme 04/08/2005
    LOCAL lnseldep, llouvvacan, lnaccu, lnaccu2, lnascol, lnnbvac
    
    WITH This
	    IF .nbre_vacances > 0
		    lnascol = .annee_scolaire && pour viter les dclenchements rptitifs 
		    lnnbvac = .nbre_vacances  && des mthodes _access
		    lnseldep = SELECT(0)
		    IF !USED("vacan")
		      USE (repfich+"vacances") ALIAS vacan SHARED AGAIN IN 0
		      llouvvacan = .T.
		    ELSE
		      llouvvacan = .F.
		    ENDIF && !USED("vacan")
		    SELECT vacan
		    SET ORDER TO && il ne faut pas d'index pour la maj
		    * on travaille bestialement : on recopie le tableau dans la
		    * table ligne par ligne sans chercher  faire coincider les
		    * dates. S'il n'y a pas assez de lignes on les cre. S'il y 
		    * en a trop on les delete en mettant l'anne scolaire  0.
		    * La prochaine reindexation les 'packera'
	      lnaccu = 1
	      SCAN ALL FOR vacan.ascol = m.lnascol WHILE m.lnaccu <= m.lnnbvac
	        REPLACE datdebut WITH .vacances( m.lnaccu, 1), datfin WITH .vacances( m.lnaccu, 2), ;
	         libelle WITH .vacances( m.lnaccu, 3), indice WITH m.lnaccu
	        lnaccu = m.lnaccu + 1
	      ENDSCAN && ALL FOR vacan.ascol = m.lnascol
	      IF m.lnaccu <= m.lnnbvac
	        * il n'y a pas assez de lignes
	        FOR m.lnaccu2 = m.lnaccu TO m.lnnbvac
	          APPEND BLANK
		        REPLACE datdebut WITH .vacances( m.lnaccu2, 1), datfin WITH .vacances( m.lnaccu2, 2), ;
		         libelle WITH .vacances( m.lnaccu2, 3), indice WITH m.lnaccu2, ;
		         ascol WITH m.lnascol
	        ENDFOR &&* m.lnaccu2 = m.lnaccu TO m.lnnbvac
	      ELSE
	        * il y a peut tre trop de lignes
	        SCAN REST FOR vacan.ascol = m.lnascol
	          REPLACE ascol WITH 0, indice WITH -1
	        ENDSCAN && REST FOR vacan.ascol = m.lnascol
	      ENDIF && m.lnaccu <= m.lnnbvac
	      COUNT FOR vacan.ascol = m.lnascol TO lnaccu
	      IF llouvvacan = .T.
	        USE IN vacan
	      ENDIF && llouvvacan = .T.
	      .yamodif_vacances = .F.
	      IF USED("vfpmou")
		      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70103, ;
		        "enregistrement_vacances", "elvclass.dates", "", "", "", m.lnaccu)
	      ENDIF && USED("vfpmou")
	      SELECT (M.lnseldep)
	    ENDIF && .nbre_vacances > 0
    ENDWITH  && This
  ENDPROC && enregistrement_vacances && jme 04/08/2005
  
  PROCEDURE ajout_vacances  && jme 18/08/2005
    LPARAMETERS pddebut, pdfin, pclibelle
    * cette procdure insre (s'il y en a dj) ou ajoute une ligne dans
    * le tableau vacances et la remplit avec les 3 paramtres
    IF !EMPTY(pddebut) AND !EMPTY(pdfin) AND !EMPTY(pclibelle) AND !EMPTY(This.sortie)
      WITH This
	      IF .nbre_vacances = 0
	        DIMENSION .vacances(1,3)
	        .vacances(1,1) = pddebut
	        .vacances(1,2) = pdfin
	        .vacances(1,3) = pclibelle
	        .nbre_vacances = 1
	      ELSE
	        * il faut insrer les nouvelles vacances au bon endroit
	        * c'est  dire que le tableau .vacances doit rester ordonner
	        * par date de dbut
	        * On utilise un 'fait' de VFP aprs avoir ajouter une ligne  la fin du
	        * tableau, si on fait une insertion, cette dernire ligne est crase. Du
	        * coup on peut y mettre la date de sortie, ce qui simplifie la recherche 
	        * de la ligne
	        LOCAL lnaccu
          .nbre_vacances = .nbre_vacances + 1
          DIMENSION .vacances( .nbre_vacances,3)
          .vacances( .nbre_vacances,1) = .sortie
	        lnaccu = 1
	        DO WHILE m.lnaccu < .nbre_vacances AND pddebut > .vacances(m.lnaccu,1)
	          lnaccu = m.lnaccu + 1
	        ENDDO && m.lnaccu <= .nbre_vacances AND pddebut > .vacances(m.lnaccu,1)
	        IF m.lnaccu >= .nbre_vacances
	          * on ajoute  la fin
	          .vacances( .nbre_vacances,1) = pddebut
	          .vacances( .nbre_vacances,2) = pdfin
	          .vacances( .nbre_vacances,3) = pclibelle
	        ELSE
	          * il faut insrer une nouvelle ligne
	          * lnaccu contient le numro de la ligne avant laquelle on insre
	          = AINS(.vacances, m.lnaccu)
	          .vacances( m.lnaccu,1) = pddebut
	          .vacances( m.lnaccu,2) = pdfin
	          .vacances( m.lnaccu,3) = pclibelle
	        ENDIF && m.lnaccu >= .nbre_vacances
	      ENDIF && This.nbre_vacances = 0
	      .yamodif_vacances = .T.
	      IF USED("vfpmou")
		      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70104, ;
		        "ajout_vacances", "elvclass.dates", DTOC(pddebut)+ " "+ DTOC(pdfin)+ " "+ ;
		         pclibelle, "", "", 0)
	      ENDIF && USED("vfpmou")
      ENDWITH  && This
    ELSE
      IF USED("vfpmou")
	      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70105, ;
	        "ajout_vacances", "elvclass.dates", "au moins 1 parametre vide", "", "", 0)
      ENDIF && USED("vfpmou")
    ENDIF && !EMPTY(pddebut) AND !EMPTY(pdfin) AND !EMPTY(pclibelle)
  ENDPROC && ajout_vacances
  
  PROCEDURE modification_vacances &&  jme 18/08/2005
    LPARAMETERS pddebut, pdfin, pclibelle
    * cette procdure modifie (s'il elle existe) une ligne dans
    * le tableau vacances et la remplit avec les 3 paramtres. La
    * recherche de la ligne se fait sur la date de dbut
    IF !EMPTY(pddebut) AND !EMPTY(pdfin) AND !EMPTY(pclibelle) AND ;
     This.nbre_vacances > 0
      WITH This
        LOCAL lnaccu
        lnaccu = 1
        DO WHILE m.lnaccu <= .nbre_vacances AND pddebut <> .vacances(m.lnaccu,1)
          lnaccu = m.lnaccu + 1
        ENDDO && m.lnaccu <= .nbre_vacances AND pddebut <> .vacances(m.lnaccu,1)
        IF m.lnaccu > .nbre_vacances
          * il y a un problme, on ne fait rien
		      IF USED("vfpmou")
			      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70109, ;
			        "modification_vacances", "elvclass.dates", "ERREUR GRAVE "+ ;
			         DTOC(pddebut)+ STR(.nbre_vacances,5), "", "", m.lnaccu)
		      ENDIF && USED("vfpmou")
        ELSE
          .vacances( m.lnaccu,1) = pddebut
          .vacances( m.lnaccu,2) = pdfin
          .vacances( m.lnaccu,3) = pclibelle
        ENDIF && m.lnaccu > .nbre_vacances
	      IF USED("vfpmou")
		      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70106, ;
		        "modification_vacances", "elvclass.dates", DTOC(pddebut)+ " "+ DTOC(pdfin)+ " "+ ;
		         pclibelle, "", "", 0)
	      ENDIF && USED("vfpmou")
        .yamodif_vacances = .T.
      ENDWITH  && This
    ELSE
      IF USED("vfpmou")
	      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70107, ;
	        "modification_vacances", "elvclass.dates", "au moins 1 parametre vide", "", "", 0)
      ENDIF && USED("vfpmou")
    ENDIF && !EMPTY(pddebut) AND !EMPTY(pdfin) AND !EMPTY(pclibelle)
  ENDPROC && modification_vacances

  PROCEDURE suppression_vacances &&  jme 18/08/2005
    LPARAMETERS pddebut
    * cette procdure supprime (s'il elle existe) une ligne dans
    * le tableau vacances. La
    * recherche de la ligne se fait sur la date de dbut

    IF !EMPTY(pddebut) AND This.nbre_vacances > 0
      WITH This
        LOCAL lnaccu
        lnaccu = 1
        DO WHILE m.lnaccu <= .nbre_vacances AND pddebut <> .vacances(m.lnaccu,1)
          lnaccu = m.lnaccu + 1
        ENDDO && m.lnaccu <= .nbre_vacances AND pddebut <> .vacances(m.lnaccu,1)
        IF m.lnaccu > .nbre_vacances
          * il y a un problme, on ne fait rien
		      IF USED("vfpmou")
			      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70119, ;
			        "suppression_vacances", "elvclass.dates", "ERREUR GRAVE "+ ;
			         DTOC(pddebut)+ STR(.nbre_vacances,5), "", "", m.lnaccu)
		      ENDIF && USED("vfpmou")
        ELSE
          = ADEL(.vacances, m.lnaccu)
          .nbre_vacances = .nbre_vacances - 1
          IF .nbre_vacances > 0
            DIMENSION .vacances( .nbre_vacances,3)
          ELSE
            DIMENSION .vacances( 1,3)
            STORE {} TO .vacances( 1,1), .vacances( 1,2)
            STORE "" TO .vacances( 1,3)
          ENDIF && .nbre_vacances > 0
        ENDIF && m.lnaccu > .nbre_vacances
        .yamodif_vacances = .T.
	      IF USED("vfpmou")
		      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70116, ;
		        "suppression_vacances", "elvclass.dates", DTOC(pddebut), "", "", .nbre_vacances)
	      ENDIF && USED("vfpmou")
      ENDWITH  && This
    ELSE
      IF USED("vfpmou")
	      INSERT INTO vfpmou VALUE (datefox, SECONDS(), 70117, ;
	        "suppression_vacances", "elvclass.dates", "au moins 1 parametre vide", "", "", 0)
      ENDIF && USED("vfpmou")
    ENDIF && !EMPTY(pddebut) 
  ENDPROC && suppression_vacances

  FUNCTION moicivsco && mois civil vers mois scolaire
    * l'original de cette mthode est dans elvfoncw
    * septembre (9) devient 2
    LPARAMETERS m
  RETURN IIF( BETWEEN(m,1, 12), IIF(BETWEEN(m,1,7),m+5,m-7), 0)
  
	FUNCTION moiscociv  && mois scolaire vers mois civil
    * l'original de cette mthode est dans elvfoncw
	  LPARAMETERS m  && mois scolaire 1 = aout
	RETURN IIF(BETWEEN(m,1,12),IIF(BETWEEN(m,1,5), m+7, m-5),0)
  
	FUNCTION datdebmoi  && date du premier du mois pass en paramtre
    * l'original de cette mthode est dans elvfoncw
	  LPARAMETERS m && m est un numro de mois civil 1-> janvier
	RETURN CTOD("01/"+STR(m,2)+"/"+STR(IIF(m<8, This.annee_scolaire+1, This.annee_scolaire),4))

	FUNCTION datfinmoi  && date fin du mois pass en paramtre
    * l'original de cette mthode est dans elvfoncw
	  PARAMETER m && m est un numro de mois civil 1-> janvier
	RETURN GOMONTH(CTOD("01/"+STR(m,2)+"/"+ ;
	 STR(IIF(m<8, This.annee_scolaire+1, This.annee_scolaire),4)),1)-1
  
  FUNCTION anneenum_to_lettreannee
    LPARAMETERS pnanneenum
*!	  RETURN CHR(65+ IIF(PCOUNT()=0, This.annee_scolaire, pnanneenum) - 1992)
  RETURN CHR(IIF(PCOUNT()=0, This.annee_scolaire, pnanneenum) - 1927)
  
ENDDEFINE && CLASS dates AS custom
